#include "pid.h"

PIDConfig PIDController::pidConfig = {
    PID_KP,
    PID_KI,
    PID_KD};

void PIDController::setConfig(float Kp, float Ki, float Kd)
{
  pidConfig.Kp = Kp;
  pidConfig.Ki = Ki;
  pidConfig.Kd = Kd;
}

float PIDController::update(float target, float current)
{
  pid.error = target - current;
  pid.integral += pid.error;
  pid.derivative = pid.error - pid.last_error;
  pid.last_error = pid.error;
  return pidConfig.Kp * pid.error + pidConfig.Ki * pid.integral + pidConfig.Kd * pid.derivative;
}
