#include "utils.h"

#define LED_FLASH_INTERVAL 1000  // LED闪烁间隔(ms)
unsigned long lastLedToggle = 0; // 上次LED切换状态的时间
bool ledState = false;           // LED当前状态

void floatToBytes(float val, uint8_t *bytes)
{
  union
  {
    float f;
    uint8_t bytes[4];
  } u;
  u.f = val;

  // 考虑大小端问题
  for (int i = 0; i < 4; i++)
  {
    bytes[i] = u.bytes[i];
  }
}

float bytesToFloat(uint8_t *bytes)
{
  union
  {
    float f;
    uint8_t bytes[4];
  } u;
  for (int i = 0; i < 4; i++)
  {
    u.bytes[i] = bytes[i];
  }
  return u.f;
}

void updateStatusLED(bool deviceConnected, int ledPin)
{
  if (deviceConnected)
  {
    digitalWrite(ledPin, HIGH);
  }
  else
  {
    unsigned long currentMillis = millis();
    if (currentMillis - lastLedToggle >= LED_FLASH_INTERVAL)
    {
      lastLedToggle = currentMillis;
      ledState = !ledState;
      digitalWrite(ledPin, ledState);
    }
  }
}